package com.examples
{
	import com.fgmap.maps.Color;
	import com.fgmap.maps.Copyright;
	import com.fgmap.maps.CopyrightCollection;
	import com.fgmap.maps.LatLng;
	import com.fgmap.maps.LatLngBounds;
	import com.fgmap.maps.TileLayerBase;
	import com.fgmap.maps.interfaces.ICopyrightCollection;
	import com.fgmap.maps.interfaces.IMap;
	
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.events.*;
	import flash.geom.Point;
	import flash.net.URLRequest;
	
	public class MyTileLayer extends TileLayerBase
	{
		private var mapMinZoom:int = 11;	//最小显示等级
		private var mapMaxZoom:int = 13;	//最大显示等级
		
		public function MyTileLayer(tileSize:Number){
			var copyrightCollection:CopyrightCollection = new CopyrightCollection();

			super(copyrightCollection, mapMinZoom, mapMaxZoom, 1);	//调用父类的方法
			
			//创建一个自己的版权说明
			copyrightCollection.addCopyright(
				new Copyright("MyCopyright",
					new LatLngBounds(new LatLng(-180, -90),
						new LatLng(180, 90)),  0,
					"这是我自己的版本说明"));
		}
		
		//覆盖加载地图数据的方法，这个很重要，地图数据从这里读取
		override public function loadTile(tilePos:Point, zoom:Number):DisplayObject {
			var testLoader:Loader = new Loader();
			var ymax:int = 1 << zoom;
			var y:int = ymax - tilePos.y - 1;
			
			var urlRequest:URLRequest;
			
			if ((zoom < mapMinZoom) || (zoom > mapMaxZoom)) {
				urlRequest =  new URLRequest("assets/tiles/nomap.png");	//没有地图时显示的内容
			}else{
				urlRequest = new URLRequest(
					"assets/tiles/" + zoom+"/"+ tilePos.x + "/" + y +".png");	//地图存放的路径，现在是本地的，也可以是服务器的地址。
			}

			testLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
			testLoader.load(urlRequest);        
			return testLoader;
		}
		
		//出错处理
		private function ioErrorHandler(event:IOErrorEvent):void {
			trace("ioErrorHandler: " + event);
		}
	}
}